#include "os_mutex.h"


#if defined(__unix__) || (defined(__APPLE__) && defined(__MACH__)) // Fuck you, apple

int OSMutex_Create(os_mutex_t* target)
{
	return pthread_mutex_init(target, NULL);
}

int OSMutex_Acquire(os_mutex_t* mutex)
{
	return pthread_mutex_lock(mutex);
}

int OSMutex_Release(os_mutex_t* mutex)
{
	return pthread_mutex_unlock(mutex);
}

int OSMutex_Destroy(os_mutex_t* mutex)
{
	return pthread_mutex_destroy(mutex);
}

#elif defined(_WIN32)

int OSMutex_Create(os_mutex_t* target)
{
	target[0] = CreateMutex(
        	NULL,              // default security attributes
        	FALSE,             // initially not owned
        	NULL);             // unnamed mutex
	if (target[0] == NULL) {
		return EXIT_FAILURE;
	}

	return EXIT_SUCCESS;
}

int OSMutex_Acquire(os_mutex_t* mutex)
{
	WaitForSingleObject(
            *mutex,    // handle to mutex
            INFINITE);  // no time-out interval

	return EXIT_SUCCESS;
}

int OSMutex_Release(os_mutex_t* mutex)
{
	return ReleaseMutex(mutex);
}

int OSMutex_Destroy(os_mutex_t* mutex)
{
	CloseHandle(mutex[0]);
	return EXIT_SUCCESS;
}

#endif
